import type express from 'express';
import { NodeTypes } from './NodeTypes';
import type { IResponseCallbackData, IWebhookManager, WaitingWebhookRequest } from './Interfaces';
import { ExecutionRepository } from './databases/repositories';
import { OwnershipService } from './services/ownership.service';
export declare class WaitingWebhooks implements IWebhookManager {
    private nodeTypes;
    private executionRepository;
    private ownershipService;
    constructor(nodeTypes: NodeTypes, executionRepository: ExecutionRepository, ownershipService: OwnershipService);
    executeWebhook(req: WaitingWebhookRequest, res: express.Response): Promise<IResponseCallbackData>;
}
