import { Command } from '@oclif/command';
import type { IUserSettings } from 'n8n-core';
import type { AbstractServer } from '../AbstractServer';
import { NodeTypes } from '../NodeTypes';
import { LoadNodesAndCredentials } from '../LoadNodesAndCredentials';
import type { IExternalHooksClass } from '../Interfaces';
export declare const UM_FIX_INSTRUCTION = "Please fix the database by running ./packages/cli/bin/n8n user-management:reset";
export declare abstract class BaseCommand extends Command {
    protected logger: import("../Logger").Logger;
    protected externalHooks: IExternalHooksClass;
    protected loadNodesAndCredentials: LoadNodesAndCredentials;
    protected nodeTypes: NodeTypes;
    protected userSettings: IUserSettings;
    protected instanceId: string;
    protected server?: AbstractServer;
    init(): Promise<void>;
    protected stopProcess(): Promise<void>;
    protected initCrashJournal(): Promise<void>;
    protected exitSuccessFully(): Promise<void>;
    protected exitWithCrash(message: string, error: unknown): Promise<void>;
    protected initBinaryManager(): Promise<void>;
    protected initExternalHooks(): Promise<void>;
    initLicense(): Promise<void>;
    finally(error: Error | undefined): Promise<void>;
}
