import { Response } from 'express';
import type { ILogger } from 'n8n-workflow';
import type { Config } from '../config';
import { OwnerRequest } from '../requests';
import type { IDatabaseCollections, IInternalHooksClass } from '../Interfaces';
import type { PostHogClient } from '../posthog';
export declare class OwnerController {
    private readonly config;
    private readonly logger;
    private readonly internalHooks;
    private readonly userService;
    private readonly settingsRepository;
    private readonly postHog?;
    constructor({ config, logger, internalHooks, repositories, postHog, }: {
        config: Config;
        logger: ILogger;
        internalHooks: IInternalHooksClass;
        repositories: Pick<IDatabaseCollections, 'Settings'>;
        postHog?: PostHogClient;
    });
    setupOwner(req: OwnerRequest.Post, res: Response): Promise<import("../Interfaces").CurrentUser>;
    dismissBanner(req: OwnerRequest.DismissBanner): Promise<{
        success: boolean;
    }>;
}
