"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSchemaBuilder = void 0;
const Column_1 = require("./Column");
const Table_1 = require("./Table");
const Indices_1 = require("./Indices");
const createSchemaBuilder = (tablePrefix, queryRunner) => ({
    column: (name) => new Column_1.Column(name),
    createTable: (tableName) => new Table_1.CreateTable(tableName, tablePrefix, queryRunner),
    dropTable: (tableName) => new Table_1.DropTable(tableName, tablePrefix, queryRunner),
    createIndex: (tableName, columnNames, isUnique = false, customIndexName) => new Indices_1.CreateIndex(tablePrefix, tableName, columnNames, isUnique, queryRunner, customIndexName),
    dropIndex: (tableName, columnNames, customIndexName) => new Indices_1.DropIndex(tablePrefix, tableName, columnNames, queryRunner, customIndexName),
});
exports.createSchemaBuilder = createSchemaBuilder;
//# sourceMappingURL=index.js.map