import type { User } from './User';
import type { SharedWorkflow } from './SharedWorkflow';
import type { SharedCredentials } from './SharedCredentials';
import { WithTimestamps } from './AbstractEntity';
export type RoleNames = 'owner' | 'member' | 'user' | 'editor';
export type RoleScopes = 'global' | 'workflow' | 'credential';
export declare class Role extends WithTimestamps {
    id: string;
    name: RoleNames;
    scope: RoleScopes;
    globalForUsers: User[];
    sharedWorkflows: SharedWorkflow[];
    sharedCredentials: SharedCredentials[];
    get cacheKey(): string;
}
