import { IConnections, IDataObject, IWorkflowSettings } from 'n8n-workflow';
import type { IBinaryKeyData, INode, IPairedItemData } from 'n8n-workflow';
import type { TagEntity } from './TagEntity';
import type { SharedWorkflow } from './SharedWorkflow';
import type { WorkflowStatistics } from './WorkflowStatistics';
import type { WorkflowTagMapping } from './WorkflowTagMapping';
import { WithTimestampsAndStringId } from './AbstractEntity';
import type { IWorkflowDb } from '../../Interfaces';
export declare class WorkflowEntity extends WithTimestampsAndStringId implements IWorkflowDb {
    name: string;
    active: boolean;
    nodes: INode[];
    connections: IConnections;
    settings?: IWorkflowSettings;
    staticData?: IDataObject;
    tags?: TagEntity[];
    tagMappings: WorkflowTagMapping[];
    shared: SharedWorkflow[];
    statistics: WorkflowStatistics[];
    pinData: ISimplifiedPinData;
    versionId: string;
    triggerCount: number;
}
export interface ISimplifiedPinData {
    [nodeName: string]: Array<{
        json: IDataObject;
        binary?: IBinaryKeyData;
        pairedItem?: IPairedItemData | IPairedItemData[] | number;
    }>;
}
