import type { ExportResult } from './types/exportResult';
import type { SourceControlledFile } from './types/sourceControlledFile';
import { VariablesService } from '../variables/variables.service';
import { TagRepository } from '../../databases/repositories';
export declare class SourceControlExportService {
    private readonly variablesService;
    private readonly tagRepository;
    private gitFolder;
    private workflowExportFolder;
    private credentialExportFolder;
    constructor(variablesService: VariablesService, tagRepository: TagRepository);
    getWorkflowPath(workflowId: string): string;
    getCredentialsPath(credentialsId: string): string;
    deleteRepositoryFolder(): Promise<void>;
    rmFilesFromExportFolder(filesToBeDeleted: Set<string>): Set<string>;
    private writeExportableWorkflowsToExportFolder;
    exportWorkflowsToWorkFolder(candidates: SourceControlledFile[]): Promise<ExportResult>;
    exportVariablesToWorkFolder(): Promise<ExportResult>;
    exportTagsToWorkFolder(): Promise<ExportResult>;
    private replaceCredentialData;
    exportCredentialsToWorkFolder(candidates: SourceControlledFile[]): Promise<ExportResult>;
}
