"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventMessageNode = void 0;
const AbstractEventMessage_1 = require("./AbstractEventMessage");
class EventMessageNode extends AbstractEventMessage_1.AbstractEventMessage {
    constructor(options) {
        super(options);
        this.__type = "$$EventMessageNode";
        if (options.payload)
            this.setPayload(options.payload);
        if (options.anonymize) {
            this.anonymize();
        }
    }
    setPayload(payload) {
        this.payload = payload;
        return this;
    }
    deserialize(data) {
        if ((0, AbstractEventMessage_1.isEventMessageOptionsWithType)(data, this.__type)) {
            this.setOptionsOrDefault(data);
            if (data.payload)
                this.setPayload(data.payload);
        }
        return this;
    }
}
exports.EventMessageNode = EventMessageNode;
//# sourceMappingURL=EventMessageNode.js.map