"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.messageEventBusDestinationFromDb = void 0;
const n8n_workflow_1 = require("n8n-workflow");
const MessageEventBusDestinationSentry_ee_1 = require("./MessageEventBusDestinationSentry.ee");
const MessageEventBusDestinationSyslog_ee_1 = require("./MessageEventBusDestinationSyslog.ee");
const MessageEventBusDestinationWebhook_ee_1 = require("./MessageEventBusDestinationWebhook.ee");
function messageEventBusDestinationFromDb(eventBusInstance, dbData) {
    const destinationData = dbData.destination;
    if ('__type' in destinationData) {
        switch (destinationData.__type) {
            case "$$MessageEventBusDestinationSentry":
                return MessageEventBusDestinationSentry_ee_1.MessageEventBusDestinationSentry.deserialize(eventBusInstance, destinationData);
            case "$$MessageEventBusDestinationSyslog":
                return MessageEventBusDestinationSyslog_ee_1.MessageEventBusDestinationSyslog.deserialize(eventBusInstance, destinationData);
            case "$$MessageEventBusDestinationWebhook":
                return MessageEventBusDestinationWebhook_ee_1.MessageEventBusDestinationWebhook.deserialize(eventBusInstance, destinationData);
            default:
                n8n_workflow_1.LoggerProxy.debug('MessageEventBusDestination __type unknown');
        }
    }
    return null;
}
exports.messageEventBusDestinationFromDb = messageEventBusDestinationFromDb;
//# sourceMappingURL=MessageEventBusDestinationFromDb.js.map