import { MessageEventBusDestination } from './MessageEventBusDestination.ee';
import * as Sentry from '@sentry/node';
import { MessageEventBusDestinationSentryOptions } from 'n8n-workflow';
import type { MessageEventBusDestinationOptions } from 'n8n-workflow';
import { MessageEventBus } from '../MessageEventBus/MessageEventBus';
import type { MessageWithCallback } from '../MessageEventBus/MessageEventBus';
export declare const isMessageEventBusDestinationSentryOptions: (candidate: unknown) => candidate is MessageEventBusDestinationSentryOptions;
export declare class MessageEventBusDestinationSentry extends MessageEventBusDestination implements MessageEventBusDestinationSentryOptions {
    dsn: string;
    tracesSampleRate: number;
    sendPayload: boolean;
    sentryClient?: Sentry.NodeClient;
    constructor(eventBusInstance: MessageEventBus, options: MessageEventBusDestinationSentryOptions);
    receiveFromEventBus(emitterPayload: MessageWithCallback): Promise<boolean>;
    serialize(): MessageEventBusDestinationSentryOptions;
    static deserialize(eventBusInstance: MessageEventBus, data: MessageEventBusDestinationOptions): MessageEventBusDestinationSentry | null;
    toString(): string;
    close(): Promise<void>;
}
