"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isDebugInEditorLicensed = exports.isAdvancedExecutionFiltersEnabled = exports.getStatusUsingPreviousExecutionStatusMethod = void 0;
const typedi_1 = require("typedi");
const License_1 = require("../License");
function getStatusUsingPreviousExecutionStatusMethod(execution) {
    if (execution.waitTill) {
        return 'waiting';
    }
    else if (execution.stoppedAt === undefined) {
        return 'running';
    }
    else if (execution.finished) {
        return 'success';
    }
    else if (execution.stoppedAt !== null) {
        return 'failed';
    }
    else {
        return 'unknown';
    }
}
exports.getStatusUsingPreviousExecutionStatusMethod = getStatusUsingPreviousExecutionStatusMethod;
function isAdvancedExecutionFiltersEnabled() {
    const license = typedi_1.Container.get(License_1.License);
    return license.isAdvancedExecutionFiltersEnabled();
}
exports.isAdvancedExecutionFiltersEnabled = isAdvancedExecutionFiltersEnabled;
function isDebugInEditorLicensed() {
    const license = typedi_1.Container.get(License_1.License);
    return license.isDebugInEditorLicensed();
}
exports.isDebugInEditorLicensed = isDebugInEditorLicensed;
//# sourceMappingURL=executionHelpers.js.map