"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkflowSelect = void 0;
const utils_1 = require("../../../utils");
const n8n_workflow_1 = require("n8n-workflow");
class WorkflowSelect {
    static get selectableFields() {
        return new Set([
            'id',
            'name',
            'active',
            'tags',
            'createdAt',
            'updatedAt',
            'versionId',
            'ownedBy',
        ]);
    }
    static fromString(rawFilter) {
        const dto = (0, n8n_workflow_1.jsonParse)(rawFilter, { errorMessage: 'Failed to parse filter JSON' });
        if (!(0, utils_1.isStringArray)(dto))
            throw new Error('Parsed select is not a string array');
        return dto.reduce((acc, field) => {
            if (!WorkflowSelect.selectableFields.has(field))
                return acc;
            return (acc[field] = true), acc;
        }, {});
    }
}
exports.WorkflowSelect = WorkflowSelect;
//# sourceMappingURL=workflow.select.dto.js.map