/// <reference types="node" />
import type express from 'express';
import { type Counter } from 'prom-client';
import EventEmitter from 'events';
import { CacheService } from '../services/cache.service';
export declare class MetricsService extends EventEmitter {
    private readonly cacheService;
    constructor(cacheService: CacheService);
    counters: Record<string, Counter<string> | null>;
    configureMetrics(app: express.Application): Promise<void>;
    private setupN8nVersionMetric;
    private setupDefaultMetrics;
    private setupApiMetrics;
    mountMetricsEndpoint(app: express.Application): void;
    private setupCacheMetrics;
    private getCounterForEvent;
    private setupMessageEventBusMetrics;
}
