import { RedisServicePubSubSubscriber } from './redis/RedisServicePubSubSubscriber';
import { RedisServicePubSubPublisher } from './redis/RedisServicePubSubPublisher';
import { RedisServiceListReceiver } from './redis/RedisServiceListReceiver';
import { RedisServiceListSender } from './redis/RedisServiceListSender';
import { RedisServiceStreamConsumer } from './redis/RedisServiceStreamConsumer';
import { RedisServiceStreamProducer } from './redis/RedisServiceStreamProducer';
export declare class RedisService {
    private redisServicePubSubSubscriber;
    private redisServicePubSubPublisher;
    private redisServiceListReceiver;
    private redisServiceListSender;
    private redisServiceStreamConsumer;
    private redisServiceStreamProducer;
    constructor(redisServicePubSubSubscriber: RedisServicePubSubSubscriber, redisServicePubSubPublisher: RedisServicePubSubPublisher, redisServiceListReceiver: RedisServiceListReceiver, redisServiceListSender: RedisServiceListSender, redisServiceStreamConsumer: RedisServiceStreamConsumer, redisServiceStreamProducer: RedisServiceStreamProducer);
    getPubSubSubscriber(): Promise<RedisServicePubSubSubscriber>;
    getPubSubPublisher(): Promise<RedisServicePubSubPublisher>;
    getListSender(): Promise<RedisServiceListSender>;
    getListReceiver(): Promise<RedisServiceListReceiver>;
    getStreamProducer(): Promise<RedisServiceStreamProducer>;
    getStreamConsumer(): Promise<RedisServiceStreamConsumer>;
}
