import type Redis from 'ioredis';
import type { Cluster, RedisOptions } from 'ioredis';
import type { RedisClientType } from './RedisServiceBaseClasses';
export declare const EVENT_BUS_REDIS_STREAM = "n8n:eventstream";
export declare const COMMAND_REDIS_STREAM = "n8n:commandstream";
export declare const WORKER_RESPONSE_REDIS_STREAM = "n8n:workerstream";
export declare const EVENT_BUS_REDIS_CHANNEL = "n8n.events";
export declare const COMMAND_REDIS_CHANNEL = "n8n.commands";
export declare const WORKER_RESPONSE_REDIS_CHANNEL = "n8n.worker-response";
export declare const WORKER_RESPONSE_REDIS_LIST = "n8n:list:worker-response";
export declare function getRedisClusterNodes(): Array<{
    host: string;
    port: number;
}>;
export declare function getRedisPrefix(customPrefix?: string): string;
export declare function getRedisStandardClient(redis: typeof Redis, redisOptions?: RedisOptions, redisType?: RedisClientType): Redis | Cluster;
export declare function getRedisClusterClient(redis: typeof Redis, redisOptions?: RedisOptions, redisType?: RedisClientType): Cluster;
export declare function getDefaultRedisClient(additionalRedisOptions?: RedisOptions, redisType?: RedisClientType): Promise<Redis | Cluster>;
