/// <reference types="node" />
import { RedisServiceBaseReceiver } from './RedisServiceBaseClasses';
type LastId = string;
type StreamName = string;
type StreamDetails = {
    lastId: LastId;
    pollingInterval: number;
    waiter: NodeJS.Timer | undefined;
};
export declare class RedisServiceStreamConsumer extends RedisServiceBaseReceiver {
    streams: Map<StreamName, StreamDetails>;
    init(): Promise<void>;
    listenToStream(stream: StreamName, lastId?: string): Promise<void>;
    stopListeningToStream(stream: StreamName): void;
    private updateStreamDetails;
    setPollingInterval(stream: StreamName, pollingInterval: number): Promise<void>;
    setLastId(stream: StreamName, lastId: string): void;
    setWaiter(stream: StreamName, waiter: NodeJS.Timeout): void;
}
export {};
