import { WebhookRepository } from '../databases/repositories';
import { CacheService } from './cache.service';
import type { WebhookEntity } from '../databases/entities/WebhookEntity';
import type { IHttpRequestMethods } from 'n8n-workflow';
import type { DeepPartial } from 'typeorm';
type Method = NonNullable<IHttpRequestMethods>;
export declare class WebhookService {
    private webhookRepository;
    private cacheService;
    constructor(webhookRepository: WebhookRepository, cacheService: CacheService);
    populateCache(): Promise<void>;
    private findCached;
    private findStaticWebhook;
    private findDynamicWebhook;
    findWebhook(method: Method, path: string): Promise<WebhookEntity | null>;
    storeWebhook(webhook: WebhookEntity): Promise<import("typeorm").InsertResult>;
    createWebhook(data: DeepPartial<WebhookEntity>): WebhookEntity;
    deleteWorkflowWebhooks(workflowId: string): Promise<WebhookEntity[]>;
    deleteInstanceWebhooks(): Promise<WebhookEntity[]>;
    private deleteWebhooks;
    getWebhookMethods(path: string): Promise<IHttpRequestMethods[]>;
}
export {};
